> ## Documentation Index
> Fetch the complete documentation index at: https://developer.watson-orchestrate.ibm.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Create Completion



## OpenAPI

````yaml post /v1/completions
openapi: 3.1.0
info:
  title: WxO Server API
  summary: API for the next gen watsonx Orchestrate stack
  description: >+

    The watsonx Orchestrate Server provides a set of APIs to power the watsonx
    Orchestrate AI assistant. This includes the following core services:


    * Orchestrate Assistant - a built-in AI assistant that powers the
    Orchestrate end-user experience.

    * Custom Assistants - a service layer for interacting with existing AI
    assistatns (such as those in watsonx Assistant).

    * Message Threads - a chat history and async message tracking store.

    * Document Store - manage collections of documents in nearly any format
    including text, pdf, html and many more.

    * Information Extraction - automatically extract clean text and images from
    any document in the Document Store.  Also extract other useful metadata like
    questions answered, keywords, and named entities.

    * Embedding - generate vector embeddings for text and images in the Document
    Store.

    * Vector Index and Retrieval - automatically index documents with rich
    metadata for vector search or hybrid search.

    * Search Engine - create a Gen AI powered search engine that works like Bing
    or Google.

    * Query Engine - configure your own RAG (Retrieval Augmented Generation)
    engine supporting advanced retrieval patterns and automated data management.

    * Model Proxy - create your own LLM model endpoints for chat completions and
    embeddings.  Supports IBM watsonx.ai, IBM BAM, OpenAI, MistralAI, or Ollama
    for local models.


    WxO API Server utilizes the following open source projects:


    * [PostgreSQL](https://www.postgresql.org/)

    * [PGVector](https://github.com/pgvector/pgvector)

    * [LlamaIndex](https://docs.llamaindex.ai/en/stable/)

    * [LangChain](https://python.langchain.com/docs/get_started/introduction)

    * [FastAPI](https://fastapi.tiangolo.com/)

    * [Unstructured](https://unstructured.io/)

    * [Celery](https://docs.celeryproject.org/en/stable/)

  version: 0.1.0
servers:
  - url: https://{api_endpoint}
    description: version
security: []
paths:
  /v1/completions:
    post:
      tags:
        - Completions
      summary: Create Completion
      operationId: Create_Completion_v1_completions_post
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/CompletionRequest'
        required: true
      responses:
        '200':
          description: Successful Response
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/CompletionResponse'
        '422':
          description: Validation Error
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/HTTPValidationError'
      security:
        - HTTPBearer: []
components:
  schemas:
    CompletionRequest:
      properties:
        model:
          type: string
          title: Model
        prompt:
          type: string
          title: Prompt
        frequency_penalty:
          anyOf:
            - type: number
            - type: 'null'
          title: Frequency Penalty
          default: 0
        presence_penalty:
          anyOf:
            - type: number
            - type: 'null'
          title: Presence Penalty
          default: 0
        logit_bias:
          anyOf:
            - additionalProperties: true
              type: object
            - type: 'null'
          title: Logit Bias
        logprobs:
          anyOf:
            - type: integer
            - type: 'null'
          title: Logprobs
        temperature:
          anyOf:
            - type: number
            - type: 'null'
          title: Temperature
          default: 1
        'n':
          anyOf:
            - type: integer
            - type: 'null'
          title: 'N'
          default: 1
        best_of:
          anyOf:
            - type: integer
            - type: 'null'
          title: Best Of
          default: 1
        seed:
          anyOf:
            - type: integer
            - type: 'null'
          title: Seed
        stop:
          anyOf:
            - items:
                type: string
              type: array
            - type: 'null'
          title: Stop
        stream:
          anyOf:
            - type: boolean
            - type: 'null'
          title: Stream
          default: false
        max_tokens:
          anyOf:
            - type: integer
            - type: 'null'
          title: Max Tokens
          default: 16
        top_p:
          anyOf:
            - type: number
            - type: 'null'
          title: Top P
          default: 1
        user:
          anyOf:
            - type: string
            - type: 'null'
          title: User
        suffix:
          anyOf:
            - type: string
            - type: 'null'
          title: Suffix
        extra_model_args:
          anyOf:
            - additionalProperties: true
              type: object
            - type: 'null'
          title: Extra Model Args
      type: object
      required:
        - model
        - prompt
      title: CompletionRequest
    CompletionResponse:
      properties:
        content:
          type: string
          title: Content
        response_metadata:
          anyOf:
            - additionalProperties: true
              type: object
            - type: 'null'
          title: Response Metadata
      type: object
      required:
        - content
      title: CompletionResponse
    HTTPValidationError:
      properties:
        detail:
          items:
            $ref: '#/components/schemas/ValidationError'
          type: array
          title: Detail
      type: object
      title: HTTPValidationError
    ValidationError:
      properties:
        loc:
          items:
            anyOf:
              - type: string
              - type: integer
          type: array
          title: Location
        msg:
          type: string
          title: Message
        type:
          type: string
          title: Error Type
      type: object
      required:
        - loc
        - msg
        - type
      title: ValidationError
  securitySchemes:
    HTTPBearer:
      type: http
      scheme: bearer

````